unit Unit1;

interface

// DATE:     October 1999
// CATEGORY: Realtime Charting
// PROBLEM:  How to use (two) THorizBar series for plotting "Age Pyramid" ?
// VERSION:  Delphi4
// AUTHOR :  MSlatinek@teemach.com


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TeEngine, Series, ExtCtrls, TeeProcs, Chart, StdCtrls, TeeFunci, TeeComma,
  TeeOpenGL;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Chart1: TChart;
    SeriesMale: THorizBarSeries;
    SeriesFemale: THorizBarSeries;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    TeeCommander1: TTeeCommander;
    TeeOpenGL1: TTeeOpenGL;
    CheckBox3: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Chart1GetAxisLabel(Sender: TChartAxis; Series: TChartSeries;
      ValueIndex: Integer; var LabelText: String);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
     Chart1.Legend.LegendStyle:=lsSeries;

     SeriesFemale.XValues.Multiplier:=-1;
     SeriesFemale.SeriesColor:=clBlue;
     SeriesFemale.Title:='Females';

     SeriesMale.SeriesColor:=clRed;
     SeriesMale.Title:='Males';
     Chart1.BottomAxis.Title.Caption:='No. of people';
     Chart1.LeftAxis.Title.Caption:='Age (years)';
     Chart1.LeftAxis.LabelsSize:=40; // to separate axis title
                                     // from axis labels enough

     // fill data, can be done differently
     SeriesMale.Add(101000,'0-10',clTeeColor);
     SeriesFemale.Add(135100,'0-10',clTeeColor);
     SeriesMale.Add(131000,'11-20',clTeeColor);
     SeriesFemale.Add(165200,'11-20',clTeeColor);
     SeriesMale.Add(133000,'21-30',clTeeColor);
     SeriesFemale.Add(195900,'21-30',clTeeColor);
     SeriesMale.Add(123800,'31-40',clTeeColor);
     SeriesFemale.Add(165100,'31-40',clTeeColor);
     SeriesMale.Add(113800,'41-50',clTeeColor);
     SeriesFemale.Add(201100,'41-50',clTeeColor);
     SeriesMale.Add(89800,'51-60',clTeeColor);
     SeriesFemale.Add(111100,'51-60',clTeeColor);
     SeriesMale.Add(55800,'61-70',clTeeColor);
     SeriesFemale.Add(91100,'61-70',clTeeColor);
     SeriesMale.Add(32800,'71-80',clTeeColor);
     SeriesFemale.Add(44100,'71-80',clTeeColor);
     SeriesMale.Add(3800,'81-',clTeeColor);
     SeriesFemale.Add(15100,'81-',clTeeColor);

     CheckBox1Click(Self);
     CheckBox2Click(Self);
     Chart1.ApplyZOrder:=false;  // get the same appearance in 3D too
                                 // i.e. both series in the same plane
end;

procedure TForm1.Chart1GetAxisLabel(Sender: TChartAxis;
  Series: TChartSeries; ValueIndex: Integer; var LabelText: String);
var tmp : string;
begin
     // ommit - from labeltext
     if (Sender=Chart1.BottomAxis) then
     begin
      tmp:=LabelText;
      LabelText:=StringReplace(tmp,'-','',[rfReplaceAll]); // Delphi 4, won't work
                                                          // in Delphi 3
     end;

end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
     SeriesMale.Active:=TCheckBox(Sender).Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
     SeriesFemale.Active:=TCheckBox(Sender).Checked;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
     TeeOpenGL1.Active:=TCheckBox(Sender).Checked;
end;

end.
